#!/usr/local/bin/perl

package Animal;
use Moose::Role;

requires 'bark';

has name => (
    is       => 'rw',
    isa      => 'Str',
    required => 1,
);

has age => (
    is      => 'rw',
    isa     => 'Int',
    default => 1,
);

around bark => sub {
    my ($code, $self) = @_;
    printf "[%s:%d] ", $self->name, $self->age;
    $code->($self);
    print "\n";
};

package Dog;
use Moose;

with 'Animal';

sub bark {
    printf "わんわん";
}

package Fox;
use Moose;

with 'Animal';

sub bark {
    printf "こんこん";
}

package main;

my $dog = Dog->new(name => "ポチ");
$dog->bark;

my $fox = Fox->new(name => "ふぉくすけ");
$fox->bark;
